(document:surround "/std/frame")

(define (apply-to-backend)
  (woo-catch/message (thunk
    (woo-write "/groups/"
      'name  (or (selector-id value) "")
      'users (users-id text)
))))

(define (reset-from-backend)
  (woo-catch/message (thunk
    (let* ((data (woo-read-first "/groups/"
          'name  (if (= 0 (selector-id count)) "" (selector-id value))))
        (name  (woo-get-option data 'name ""))
        (label (woo-get-option data 'label ""))
        (users (woo-get-option data 'users ""))
        (prot  (woo-get-option data 'protected #t)) )
      (name-id  text (string-append "<b>" name "</b>"))
      (label-id text (string-append "<b>" label "</b>"))
      (users-id text users)
      (delete-btn visibility (not prot))
))))

(define (reset-list)
  (selector-id (enumref "/groups/"))
  (if (> (selector-id count) 0) (selector-id current 0))
  (reset-from-backend)
)

(define (reset-skippings)
(format #t "reset skippings~%" )
  (woo-catch/message (thunk
    (woo-try "set_skippings" "/groups/"
      'skip_empty   (skip-empty-id value)
      'skip_system  (skip-system-id value)
      'skip_primary (skip-primary-id value)
  )))
  (reset-list)
)


(define (group-del)
  (woo-catch/message (thunk
    (woo-try "delete" "/groups" 'name (selector-id value))))
  (reset-list)
)

(define (group-add)
  (if (woo-catch/message (thunk
    (woo-try "new" "/groups" 'name (new-id value))))
    (begin
      (skip-empty-id value #f)
      (reset-skippings)
      (selector-id value (new-id value))
      (new-id value "")
      (reset-from-backend)
    )))

;;;

(gridbox columns "10;80;10"

  (spacer)
  (gridbox columns "0;100;0"
    (label text (_ "New group:" ))
    (document:id new-id (edit))
    (button text (_ "Create") (when clicked (group-add))) )
  (spacer)

  (spacer)
  (gridbox columns "40;60"

    (document:id selector-id (listbox
      (when selected (reset-from-backend))))

    (groupbox text ""
      (gridbox columns "0;100"
        (label text (_ "System name:") align "right")
        (document:id name-id (label text "" text-wrap #t))
        (label text (_ "Description:") align "right")
        (document:id label-id (label text "" text-wrap #t))

        (label text (_ "Users:") align "right;top")
        (document:id users-id (textbox))
        (spacer)
      )

      (gridbox columns "33;33;33"
        (button text (_ "Apply")  (when clicked (apply-to-backend) (reset-from-backend)))
        (button text (_ "Reset")  (when clicked (reset-from-backend)))
        (document:id delete-btn (button text (_ "Delete") (when clicked (group-del))))
      )
    )

    (gridbox columns "100"
      (document:id skip-system-id  (checkbox (_ "Skip system groups")
        value #f (when toggled (reset-skippings))))
      (document:id skip-primary-id (checkbox (_ "Skip primary groups")
        value #t (when toggled (reset-skippings))))
      (document:id skip-empty-id   (checkbox (_ "Skip empty groups")
        value #f (when toggled (reset-skippings)))))

  )
  (spacer)
)


(document:root (when loaded (reset-list)))
